package sorts;

import util.OArrays;

/**
 * Sort.java
 * Created by Stijn Strickx on May 21, 2008
 * Copyright 2008 Stijn Strickx, All rights reserved
 */

/**
 * The datatype conversions for the arrays won't influence 
 * the time complexity of the sorting algorithms.
 * Without these conversions,
 * the algorithms would have to be re-written for every primitive datatype.
 */

public class Sort {
    
    public static <T extends Comparable<? super T>> void selectionSort(T[] a){
        (new SelectionSort()).sort(a);
    }
    public static int[] selectionSort(int[] a){
        Integer[] b = OArrays.toObjectArray(a);
        selectionSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static long[] selectionSort(long[] a){
        Long[] b = OArrays.toObjectArray(a);
        selectionSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static double[] selectionSort(double[] a){
        Double[] b = OArrays.toObjectArray(a);
        selectionSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static float[] selectionSort(float[] a){
        Float[] b = OArrays.toObjectArray(a);
        selectionSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static char[] selectionSort(char[] a){
        Character[] b = OArrays.toObjectArray(a);
        selectionSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static boolean[] selectionSort(boolean[] a){
        Boolean[] b = OArrays.toObjectArray(a);
        selectionSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static byte[] selectionSort(byte[] a){
        Byte[] b = OArrays.toObjectArray(a);
        selectionSort(b);
        return OArrays.toPrimitiveArray(b);
    }
}